//+------------------------------------------------------------------+
//|                                                RPRHPPERC-T01.mq4 |
//|                          Copyright  2011, HomeSoft-Tartan Corp. |
//|                                          http://www.fxexperts.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, HomeSoft-Tartan Corp."
#property link      "http://www.fxexperts.ru"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_width1  2
#property indicator_width2  1
#property indicator_width3  1
#property indicator_width4  2
#property indicator_width5  2
#property indicator_color1  Blue
#property indicator_color2  Red
#property indicator_color3  Blue
#property indicator_color4  LimeGreen
#property indicator_color5  Red

extern int       per    = 50;
extern int       mBar   = 250;
extern double    por    = 3;
extern int       pr     = 2;
extern int       info   = 1; 
extern int       sound  = 1;
extern double    ds     = 10; 


double HPNBuf[],HPBuf[],DnBuf[],UpBuf[],SBuf[],GRBuf[],x1,x2,x3,x4,rpnu,rpnor,grad,sprb,sprs;
int    cnt,kb,ks,m,n,p5,size,bar,pp,mm,kks,kkb,ssig,bsig,kbb,kss;
string shrift="Arial";
bool   ft;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
     ObjectsDeleteAll();
     mBar   = 300;
     x1 = 0.3;
     x2 = 0.8;   
     x3 = 0.8;  
     x4 = 0.3;
     size=14;
     ft=true;
if  (Digits>=5) p5=10; else p5=1;

     SetIndexBuffer(0,HPNBuf);
     SetIndexStyle(0,DRAW_LINE);
          
     SetIndexBuffer(3,HPBuf);  
     SetIndexStyle(3,DRAW_LINE);
              
     SetIndexBuffer(1,DnBuf);  
     SetIndexBuffer(2,UpBuf);  
     SetIndexStyle(1,DRAW_ARROW,0,1);
     SetIndexStyle(2,DRAW_ARROW,0,1);                
     SetIndexArrow(1,242);
     SetIndexArrow(2,241);  
     
     SetIndexBuffer(4,SBuf);
     SetIndexStyle(4,DRAW_ARROW,0,2);
     SetIndexArrow(4,172); 
     
     SetIndexBuffer(5,GRBuf);
     SetIndexStyle(5,DRAW_NONE);  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  Comment("");
  ObjectsDeleteAll(); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//----   
 for (cnt=mBar;cnt>=0;cnt--)
  {   UpBuf[cnt]=0;DnBuf[cnt]=0;
      rpnu=iCustom(NULL,0,"HP-T01",per,mBar,0,cnt);
      HPBuf[cnt]=rpnu;
      rpnor=NormalizeDouble(rpnu,pr);
      HPNBuf[cnt]=rpnor;   
       
  if (perc()>=por && oper()<=perc() && HPBuf[cnt+1]<HPBuf[cnt] && kb==0 && Close[cnt]>rpnor&& Close[cnt]>Open[cnt])
     {kb=1;ks=0;UpBuf[cnt]=Low[cnt]-ds*Point;bsig=1;ssig=0;kbb=0;
  if (cnt==0 && n==0 && sound==1) {m=0;n=1;PlaySound("StandUp2.wav");}}
  if (perc()<-por && oper()>=perc() && HPBuf[cnt+1]>HPBuf[cnt] && ks==0 && Close[cnt]<rpnor&& Close[cnt]<Open[cnt])
     {ks=1;kb=0;DnBuf[cnt]=High[cnt]+ds*Point;ssig=1;bsig=0;kss=0;
  if (cnt==0 && m==0 && sound==1) {m=1;n=0;PlaySound("StandUp2.wav");}}   
      
  if (oper()>perc()) grad=-1;
  if (oper()==perc() && perc()<-0.1) grad=-1;
  if (oper()<perc()) grad=1;
  if (oper()==perc() && perc()>0.1) grad=1;
  if (oper()==perc() && oper()<=0.1 && oper()>=-0.1) grad=0;  
      GRBuf[cnt]=grad;
     
  if (bar!=Bars || ft)
  {   SBuf[cnt]=0;
  if (GRBuf[cnt]==1)
  {   ObjectSetText("GRAD", "Gradient= "+DoubleToStr(grad,1), size, shrift, Green);}      
  if (GRBuf[cnt]==-1)
  {   ObjectSetText("GRAD", "Gradient= "+DoubleToStr(grad,1), size, shrift, Red);}
  if (GRBuf[cnt]==0)
  {   
      ObjectSetText("GRAD", "Gradient= "+DoubleToStr(grad,1), size, shrift, Blue);}
      ObjectSet("GRAD", OBJPROP_XDISTANCE, 1100);
      ObjectSet("GRAD", OBJPROP_YDISTANCE, 20);
      ObjectCreate("GRAD", OBJ_LABEL, 0,1050,20); 
      
  if (oper()>0)
   {  ObjectSetText("OPER", "OnePerc= "+DoubleToStr(oper(),1), size, shrift, Green);}
  if (oper()<0)
   {  ObjectSetText("OPER", "OnePerc= "+DoubleToStr(oper(),1), size, shrift, Red);}
  if (oper()==0)
   {  
      ObjectSetText("OPER", "OnePerc= "+DoubleToStr(oper(),1), size, shrift, Blue);}      
      ObjectSet("OPER", OBJPROP_XDISTANCE, 1100);
      ObjectSet("OPER", OBJPROP_YDISTANCE, 40);
      ObjectCreate("OPER", OBJ_LABEL, 0,1050,20);      
      
  if (perc()>0)
   {  ObjectSetText("NPER", "NulPerc=  "+DoubleToStr(perc(),1), size, shrift, Green);}
  if (perc()<0)
   {  ObjectSetText("NPER", "NulPerc=  "+DoubleToStr(perc(),1), size, shrift, Red);}
  if (perc()==0)
   {  
      ObjectSetText("NPER", "NulPerc=  "+DoubleToStr(perc(),1), size, shrift, Blue);}      
      ObjectSet("NPER", OBJPROP_XDISTANCE, 1100);
      ObjectSet("NPER", OBJPROP_YDISTANCE, 60);
      ObjectCreate("NPER", OBJ_LABEL, 0,1050,20);    
      
      ft=false; 
  }
  if (bsig==1 && perc()>-por && perc()<por && kkb==0) {SBuf[cnt]=High[cnt]+1*Point;kks=0;kkb=1;sprb=SBuf[cnt];sprs=0;}
  if (bsig==1 && perc()>=por && sprb!=0 && sprb<Close[cnt] && Close[cnt]>Open[cnt] && kbb==0) {kbb=1;kss=0;UpBuf[cnt]=Low[cnt]-15*Point;kkb=0;}
  if (ssig==1 && perc()>-por && perc()<por && kks==0) {SBuf[cnt]=Low[cnt]-1*Point;kks=1;kkb=0;sprs=SBuf[cnt];sprb=0;}
  if (ssig==1 && perc()<=-por && sprs!=0 && sprs>Close[cnt] && Close[cnt]<Open[cnt] && kss==0) {kss=1;kbb=0;DnBuf[cnt]=High[cnt]+15*Point;kks=0;}
  }
      bar=Bars;      
//----
   return(0);
  }
//+------------------------------------------------------------------+

double perc() 
  {
   double w1 = x1;
   double w2 = x2;
   double w3 = x3;
   double w4 = x4;
   
   int a1 = (((iCustom(NULL,0,"HP-T01",per,mBar,0,cnt+1)-iCustom(NULL,0,"HP-T01",per,mBar,0,cnt+2))/Point)/p5); 
   int a2 = (((iCustom(NULL,0,"HP-T01",per,mBar,0,cnt+2)-iCustom(NULL,0,"HP-T01",per,mBar,0,cnt+3))/Point)/p5); 
   int a3 = (((iCustom(NULL,0,"HP-T01",per,mBar,0,cnt+3)-iCustom(NULL,0,"HP-T01",per,mBar,0,cnt+4))/Point)/p5);  
   int a4 = (((iCustom(NULL,0,"HP-T01",per,mBar,0,cnt+4)-iCustom(NULL,0,"HP-T01",per,mBar,0,cnt+5))/Point)/p5);  
 
   return ( w1 * a1 + w2 * a2 + w3 * a3 + w4 * a4 );
   }
double oper() 
  {
   double w1 = x1;
   double w2 = x2;
   double w3 = x3;
   double w4 = x4;
   
   int a1 = (((iCustom(NULL,0,"HP-T01",per,mBar,0,cnt+2)-iCustom(NULL,0,"HP-T01",per,mBar,0,cnt+3))/Point)/p5); 
   int a2 = (((iCustom(NULL,0,"HP-T01",per,mBar,0,cnt+3)-iCustom(NULL,0,"HP-T01",per,mBar,0,cnt+4))/Point)/p5); 
   int a3 = (((iCustom(NULL,0,"HP-T01",per,mBar,0,cnt+4)-iCustom(NULL,0,"HP-T01",per,mBar,0,cnt+5))/Point)/p5);  
   int a4 = (((iCustom(NULL,0,"HP-T01",per,mBar,0,cnt+5)-iCustom(NULL,0,"HP-T01",per,mBar,0,cnt+6))/Point)/p5);  
 
   return ( w1 * a1 + w2 * a2 + w3 * a3 + w4 * a4 );
   }   